
// ----------------------------------------------------------------------

void drawCOMMsg() {
  // put text in COM value field
  if (comFlag < 1) {TR = 255;}
  drawTxtField("                 ", 94, 389);
  drawTxtField(msgCOM, 94, 389); TR = 0;
}

// ----------------------------------------------------------------------

void drawDsliderVal() {
  // put text in Val field
  drawTxtField("                  ", 680, 279);
  drawTxtField(str(DsliderVal/10.0), 708, 279);
}

// ----------------------------------------------------------------------

void drawGraphMode() {
  // puts the graph mode in the top right-hand button
  TR = 0; TG = 0; TB = 0;
  if (G_Mode == 0) {drawTxtField("Data", 1134, 17);}  // in graph mode
  else {drawTxtField("Graph", 1130, 17);}             // in data mode
}

// ----------------------------------------------------------------------

void drawHelpMsg() {
  // put text in HELP value field
  TB = 255; // Help text colour is blue by default
  if (comFlag < 1) {TB = 0; TR = 255;}
  drawTxtField("                                                                                                                                                        ", 42, 430);
  drawTxtField(Help$, 335 - (3 * Help$.length()), 430); TB = 0; TR = 0;
}

// ----------------------------------------------------------------------

void drawIsliderVal() {
  // put text in Val field
  drawTxtField("                  ", 680, 222);
  drawTxtField(str(IsliderVal/100.0), 708, 222);
}

// ----------------------------------------------------------------------

void drawLamps() {
  // draw lamps based on flags
  fill(0,150,255); stroke(0,0,0); strokeWeight(1); // blue
  if (D_ON) {ellipse(281,80,21,21);} // D button lamp
  if (I_ON) {ellipse(199,80,21,21);} // I button lamp
  
  if (MemDown) {
    fill(200,200,64); // yellow
    ellipse(362,80,21,21); // Mem button lamp
  } else {
    fill(64,255,64); // green
    if (M_ON) {ellipse(362,80,21,21);} // Mem button lamp
  }
  
  if (PID_SPJ > 0) {
    switch(PID_SPJ) {
      case 1:  // yellow
        fill(232,232,64); break;
      case 2:  // green
        fill(64,255,64); break;
      case 3:  // red
        fill(255,64,64); break;
    } ellipse(445,80,21,21); // Mem button lamp
  }
}

// ----------------------------------------------------------------------

void drawMouseXY() {
  // draws the value of mouse x,y top left
  // draws a full X/Y axis on the form
  // draw full X/Y axis
  stroke(255,0,0,128); strokeWeight(1);
  line(0,mY,1199,mY); line(mX,0,mX,799);

  int zX,zY;
  if (mX > 599) {zX = mX - 70;} else {zX = mX + 6;}
  if (mY > 399) {zY = mY - 38;} else {zY = mY + 8;}
  stroke(0,0,0); fill(255,255,255); rect(zX,zY,64,30);
  fill(0,0,0); text("X=" + mX, zX + 4, zY + 14); text("Y=" + mY, zX + 4, zY + 28);
  mXL = mX; mYL = mY;
}

// ----------------------------------------------------------------------

void drawPsliderVal() {
  // put text in Val field
  drawTxtField("                  ", 680, 172);
  drawTxtField(str(PsliderVal/10.0), 708, 172);
}

// ----------------------------------------------------------------------

void drawRxMsg() {
  // put text in the Rx field
  drawTxtField("                                                                                    ", 246, 389);
  drawTxtField(msgRx, 246, 389);
}

// ----------------------------------------------------------------------

void drawSliderD() {
  // draw the 'D' slider knob
  int zXw = 20; stroke(0,0,0); 
  strokeWeight(2); fill(255,255,255); 
  rect(JoyDval-zXw,266,zXw+zXw,40);
}

// ----------------------------------------------------------------------

void drawSliderI() {
  // draw the 'I' slider knob
  int zXw = 20; stroke(0,0,0); 
  strokeWeight(2); fill(255,255,255); 
  rect(JoyIval-zXw,213,zXw+zXw,40);
}

// ----------------------------------------------------------------------

void drawSliderP() {
  // draw the 'P' slider knob
  int zXw = 20; stroke(0,0,0); 
  strokeWeight(2); fill(255,255,255); 
  rect(JoyPval-zXw,159,zXw+zXw,40);
}

// ----------------------------------------------------------------------

void drawSliderS() {
  // draw the 'S' slider knob
  int zXw = 20; stroke(0,0,0); 
  strokeWeight(2); fill(255,255,255); 
  rect(JoySval-zXw,323,zXw+zXw,40);
}

// ----------------------------------------------------------------------

void drawSsliderVal() {
  // put text in Val field
  drawTxtField("                  ", 680, 336);
  drawTxtField(str(SsliderVal/10000.0), 708, 336);
}

// ----------------------------------------------------------------------

void drawTxMsg() {
  // put text in Tx field
  drawTxtField("                             ", 640, 389);
  drawTxtField(msgTx, 640, 389);
}

// ----------------------------------------------------------------------

void drawTxtField(String zM,int zX, int zY) {
  stroke(242,242,242); fill(242,242,242); 
  rect(zX, zY, 8+textWidth(zM), 14);
  fill(TR,TG,TB); text(zM, zX+4, zY+12);
}
