
// ----------------------------------------------------------------------

void copyGraphData() {
  // copies active graph data to clipboard as CSV data
  G_Pause = true;  // pause graph if it is moving
  String zCD = ""; boolean zDV; String zCS = "";
  if (GraphRange < GraphDepth) {
    // the value arrays are not yet full so data from [0] to [GraphPnt-1]
    for (G_Pp = 1; G_Pp < GraphPnt; G_Pp++) {
      zDV = false; zCS = "";
      if (G_Plot0) {zCD = zCD + zCS + str(GraphVal0[G_Pp]); zDV = true; zCS = ",";}
      if (G_Plot1) {zCD = zCD + zCS + str(GraphVal1[G_Pp]); zDV = true; zCS = ",";}
      if (G_Plot2) {zCD = zCD + zCS + str(GraphVal2[G_Pp]); zDV = true; zCS = ",";}
      if (G_Plot3) {zCD = zCD + zCS + str(GraphVal3[G_Pp]); zDV = true; zCS = ",";}
      if (zDV) {zCD = zCD + Ln;}  // add a linme feed to each line
    }
  } else {
    // the value arrays are now full and being overwritten, so we start
    // with the value ahead of GraphPnt
    G_Ps = 0; if (GraphPnt < (GraphDepth-1)) {G_Ps = GraphPnt + 1;}
    for (G_Pp = 1; G_Pp < GraphDepth; G_Pp++) {
      zDV = false; zCS = "";
      if (G_Plot0) {zCD = zCD + zCS + str(GraphVal0[G_Ps]); zDV = true; zCS = ",";}
      if (G_Plot1) {zCD = zCD + zCS + str(GraphVal1[G_Ps]); zDV = true; zCS = ",";}
      if (G_Plot2) {zCD = zCD + zCS + str(GraphVal2[G_Ps]); zDV = true; zCS = ",";}
      if (G_Plot3) {zCD = zCD + zCS + str(GraphVal3[G_Ps]); zDV = true; zCS = ",";}
      if (zDV) {zCD = zCD + Ln;}  // add a linme feed to each line
      G_Ps++; if (G_Ps >= GraphDepth) {G_Ps = 0;}
    }
  }
  GClip.copy(zCD);
}

// ----------------------------------------------------------------------

void drawAxis() {
  // called to clear the graph and draw axis graphics
  background(imgGraph); // define background RGB colour
  //background(200,200,200); // define background RGB colour

  // show limits on Y-axis
  fill(0,0,0); text(GMax, 50, 52); // upper axis value
  text(GMin + ((GMax - GMin)/2.0), 50, 408); // centre value
  text(GMin, 50, 752); // lower axis value

  // display number of points in graph
  text(GraphDepth, 1140, 621);

  // display RPnn number
  text(RPnn, 1148, 673);
}

// ----------------------------------------------------------------------

void drawData() {
  // list the data stored in GraphVals[]
  int zListDepth = 49; int zCY = 50; int zP;
  background(imgGraph);  //load background image
  text(RPnn, 1148, 673); // display RPnn number
  fill(242,242,242); rect(400,zCY,400,698); zCY += 4;
  
  if (GraphRange < GraphDepth) {
    // the value arrays are not yet full so draw from [n] to [GraphPnt-1]
    if (GraphPnt < zListDepth) {
      // data is just filling up, so start from the beginning
      for (zP = 0;zP < GraphPnt;zP++) {
        if (G_Plot0) {TR =   0; TG =   0; TB =   0; drawTxtField(str(GraphVal0[zP]),GTCX0,zCY);}
        if (G_Plot1) {TR = 255; TG =   0; TB =   0; drawTxtField(str(GraphVal1[zP]),GTCX1,zCY);}
        if (G_Plot2) {TR =   0; TG =   0; TB = 255; drawTxtField(str(GraphVal2[zP]),GTCX2,zCY);}
        if (G_Plot3) {TR =   0; TG = 220; TB =   0; drawTxtField(str(GraphVal3[zP]),GTCX3,zCY);}
        zCY += 14;
      }
    } else {
      // data depth exceeds list depth so start towards the end
      zP = GraphPnt - zListDepth;
      for (int zN = 0;zN < zListDepth;zN++) {
        if (G_Plot0) {TR =   0; TG =   0; TB =   0; drawTxtField(str(GraphVal0[zP]),GTCX0,zCY);}
        if (G_Plot1) {TR = 255; TG =   0; TB =   0; drawTxtField(str(GraphVal1[zP]),GTCX1,zCY);}
        if (G_Plot2) {TR =   0; TG =   0; TB = 255; drawTxtField(str(GraphVal2[zP]),GTCX2,zCY);}
        if (G_Plot3) {TR =   0; TG = 220; TB =   0; drawTxtField(str(GraphVal3[zP]),GTCX3,zCY);}
        zCY += 14; zP++;
      }
    }
  } else {
    // graph data has exceeded array depth and we are scrolling data
    zP = GraphPnt - zListDepth;
    if (zP < 0) {zP = GraphDepth + zP - 1;}
    for (int zN = 0;zN < zListDepth;zN++) {
      if (G_Plot0) {TR =   0; TG =   0; TB =   0; drawTxtField(str(GraphVal0[zP]),GTCX0,zCY);}
      if (G_Plot1) {TR = 255; TG =   0; TB =   0; drawTxtField(str(GraphVal1[zP]),GTCX1,zCY);}
      if (G_Plot2) {TR =   0; TG =   0; TB = 255; drawTxtField(str(GraphVal2[zP]),GTCX2,zCY);}
      if (G_Plot3) {TR =   0; TG = 220; TB =   0; drawTxtField(str(GraphVal3[zP]),GTCX3,zCY);}
      zCY += 14; zP++; if (zP >= GraphDepth) {zP = 0;}
    }
  }
  TR = 0; TG = 0; TB = 0; 
}

// ----------------------------------------------------------------------

void drawGraph() {
  // use the data stored in GraphVals[] to plot points
  int zPx0 = GraphMargin;           // X-axis plot pointer
  int zPx1 = zPx0 + G_PxInc;        // X-axis plot pointer
  if (GMin == GMax) {GMax += 0.1;}  // avoid map(0,0)
  if (GraphRange < GraphDepth) {
    // the value arrays are not yet full so draw from [0] to [GraphPnt-1]
    G_Py0 = (int)map(GraphVal0[0],GMin,GMax,G_WinMax,G_WinMin);
    if (G_Py0 > (int)G_WinMax) {G_Py0 = (int)G_WinMax;}
    if (G_Py0 < (int)G_WinMin) {G_Py0 = (int)G_WinMin;}
    G_Py1 = (int)map(GraphVal1[0],GMin,GMax,G_WinMax,G_WinMin);
    if (G_Py1 > (int)G_WinMax) {G_Py1 = (int)G_WinMax;}
    if (G_Py1 < (int)G_WinMin) {G_Py1 = (int)G_WinMin;}
    G_Py2 = (int)map(GraphVal2[0],GMin,GMax,G_WinMax,G_WinMin);
    if (G_Py2 > (int)G_WinMax) {G_Py2 = (int)G_WinMax;}
    if (G_Py2 < (int)G_WinMin) {G_Py2 = (int)G_WinMin;}
    G_Py3 = (int)map(GraphVal3[0],GMin,GMax,G_WinMax,G_WinMin);
    if (G_Py3 > (int)G_WinMax) {G_Py3 = (int)G_WinMax;}
    if (G_Py3 < (int)G_WinMin) {G_Py3 = (int)G_WinMin;}
    for (G_Pp = 1; G_Pp < GraphPnt; G_Pp++) {
      G_Vy0 = (int)map(GraphVal0[G_Pp],GMin,GMax,G_WinMax,G_WinMin);
      if (G_Vy0 > (int)G_WinMax) {G_Vy0 = (int)G_WinMax;}
      if (G_Vy0 < (int)G_WinMin) {G_Vy0 = (int)G_WinMin;}
      G_Vy1 = (int)map(GraphVal1[G_Pp],GMin,GMax,G_WinMax,G_WinMin);
      if (G_Vy1 > (int)G_WinMax) {G_Vy1 = (int)G_WinMax;}
      if (G_Vy1 < (int)G_WinMin) {G_Vy1 = (int)G_WinMin;}
      G_Vy2 = (int)map(GraphVal2[G_Pp],GMin,GMax,G_WinMax,G_WinMin);
      if (G_Vy2 > (int)G_WinMax) {G_Vy2 = (int)G_WinMax;}
      if (G_Vy2 < (int)G_WinMin) {G_Vy2 = (int)G_WinMin;}
      G_Vy3 = (int)map(GraphVal3[G_Pp],GMin,GMax,G_WinMax,G_WinMin);
      if (G_Vy3 > (int)G_WinMax) {G_Vy3 = (int)G_WinMax;}
      if (G_Vy3 < (int)G_WinMin) {G_Vy3 = (int)G_WinMin;}
      if (G_Plot0) {stroke(0); line(zPx0,G_Py0,zPx1 + 1,G_Vy0);}
      if (G_Plot1) {stroke(255,0,0); line(zPx0,G_Py1,zPx1 + 1,G_Vy1);}
      if (G_Plot2) {stroke(0,0,255); line(zPx0,G_Py2,zPx1 + 1,G_Vy2);}
      if (G_Plot3) {stroke(0,220,0); line(zPx0,G_Py3,zPx1 + 1,G_Vy3);}
      zPx0 = zPx1; zPx1 += G_PxInc; 
      G_Py0 = G_Vy0; G_Py1 = G_Vy1; G_Py2 = G_Vy2; G_Py3 = G_Vy3;
    }
  } else {
    // the value arrays are now full and being overwritten, so we start
    // with the value ahead of GraphPnt
    G_Ps = 0; if (GraphPnt < (GraphDepth-1)) {G_Ps = GraphPnt + 1;}
    G_Py0 = (int)map(GraphVal0[G_Ps],GMin,GMax,G_WinMax,G_WinMin);
    if (G_Py0 > (int)G_WinMax) {G_Py0 = (int)G_WinMax;}
    if (G_Py0 < (int)G_WinMin) {G_Py0 = (int)G_WinMin;}
    G_Py1 = (int)map(GraphVal1[G_Ps],GMin,GMax,G_WinMax,G_WinMin);
    if (G_Py1 > (int)G_WinMax) {G_Py1 = (int)G_WinMax;}
    if (G_Py1 < (int)G_WinMin) {G_Py1 = (int)G_WinMin;}
    G_Py2 = (int)map(GraphVal2[G_Ps],GMin,GMax,G_WinMax,G_WinMin);
    if (G_Py2 > (int)G_WinMax) {G_Py2 = (int)G_WinMax;}
    if (G_Py2 < (int)G_WinMin) {G_Py2 = (int)G_WinMin;}
    G_Py3 = (int)map(GraphVal3[G_Ps],GMin,GMax,G_WinMax,G_WinMin);
    if (G_Py3 > (int)G_WinMax) {G_Py3 = (int)G_WinMax;}
    if (G_Py3 < (int)G_WinMin) {G_Py3 = (int)G_WinMin;}
    for (G_Pp = 1; G_Pp < GraphDepth; G_Pp++) {
      G_Vy0 = (int)map(GraphVal0[G_Ps],GMin,GMax,G_WinMax,G_WinMin);
      if (G_Vy0 > (int)G_WinMax) {G_Vy0 = (int)G_WinMax;}
      if (G_Vy0 < (int)G_WinMin) {G_Vy0 = (int)G_WinMin;}
      G_Vy1 = (int)map(GraphVal1[G_Ps],GMin,GMax,G_WinMax,G_WinMin);
      if (G_Vy1 > (int)G_WinMax) {G_Vy1 = (int)G_WinMax;}
      if (G_Vy1 < (int)G_WinMin) {G_Vy1 = (int)G_WinMin;}
      G_Vy2 = (int)map(GraphVal2[G_Ps],GMin,GMax,G_WinMax,G_WinMin);
      if (G_Vy2 > (int)G_WinMax) {G_Vy2 = (int)G_WinMax;}
      if (G_Vy2 < (int)G_WinMin) {G_Vy2 = (int)G_WinMin;}
      G_Vy3 = (int)map(GraphVal3[G_Ps],GMin,GMax,G_WinMax,G_WinMin);
      if (G_Vy3 > (int)G_WinMax) {G_Vy3 = (int)G_WinMax;}
      if (G_Vy3 < (int)G_WinMin) {G_Vy3 = (int)G_WinMin;}
      if (G_Plot0) {stroke(0); line(zPx0,G_Py0,zPx1 + 1,G_Vy0);}
      if (G_Plot1) {stroke(255,0,0); line(zPx0,G_Py1,zPx1 + 1,G_Vy1);}
      if (G_Plot2) {stroke(0,0,255); line(zPx0,G_Py2,zPx1 + 1,G_Vy2);}
      if (G_Plot3) {stroke(0,220,0); line(zPx0,G_Py3,zPx1 + 1,G_Vy3);}
      zPx0 = zPx1; zPx1 += G_PxInc; 
      G_Py0 = G_Vy0; G_Py1 = G_Vy1; G_Py2 = G_Vy2; G_Py3 = G_Vy3;
      G_Ps++; if (G_Ps >= GraphDepth) {G_Ps = 0;}  // wrap the data pointer
    }
  }
  if (!G_Pause) {return;}
  
  // graph plotted in 'Pause' state so include data under mouse
  if ((mX >= GraphMargin) && (mX <= 1100) && (mY >= 49) && (mY <= 750)) {
    // mouse is in graph area
    // present coordinates based on X and Y axis
    GX = (1 + mX - GraphMargin)/G_PxInc;
    GY = map((float)mY,G_WinMax,G_WinMin,GMin,GMax);
    if (abs(GY) < 10.0) {GFormat = nf(GY,1,3);}
    else if (abs(GY) < 100.0) {GFormat = nf(GY,2,2);}
    else if (abs(GY) < 1000.0) {GFormat = nf(GY,3,1);}
    else {GFormat = nf(GY,3,1);}
    fill(0,0,0); text(GFormat + "  @  " + GX, 108, 33);
    
    // reveal values stored in the array
    if (GraphRange < GraphDepth) {
      // in first pass of graph plot, filling up arrays
      if (G_Plot0) {
        if (GX < GraphRange) {
          GY = GraphVal0[GX];
          if (abs(GY) < 10.0) {GFormat = nf(GY,1,3);}
          else if (abs(GY) < 100.0) {GFormat = nf(GY,2,2);}
          else if (abs(GY) < 1000.0) {GFormat = nf(GY,3,1);}
          else {GFormat = nf(GY,3,1);}
        } else {GFormat = "---.--";}
      } else {GFormat = "....";}
      text(GFormat, 108, 776);
  
      if (G_Plot1) {
        if (GX < GraphRange) {
          GY = GraphVal1[GX];
          if (abs(GY) < 10.0) {GFormat = nf(GY,1,3);}
          else if (abs(GY) < 100.0) {GFormat = nf(GY,2,2);}
          else if (abs(GY) < 1000.0) {GFormat = nf(GY,3,1);}
          else {GFormat = nf(GY,3,1);}
        } else {GFormat = "---.--";}
      } else {GFormat = "....";}
      fill(255,0,0); text(GFormat, 208, 776);
  
      if (G_Plot2) {
        if (GX < GraphRange) {
          GY = GraphVal2[GX];
          if (abs(GY) < 10.0) {GFormat = nf(GY,1,3);}
          else if (abs(GY) < 100.0) {GFormat = nf(GY,2,2);}
          else if (abs(GY) < 1000.0) {GFormat = nf(GY,3,1);}
          else {GFormat = nf(GY,3,1);}
        } else {GFormat = "---.--";}
      } else {GFormat = "....";}
      fill(0,0,255); text(GFormat, 308, 776);
  
      if (G_Plot3) {
        if (GX < GraphRange) {
          GY = GraphVal3[GX];
          if (abs(GY) < 10.0) {GFormat = nf(GY,1,3);}
          else if (abs(GY) < 100.0) {GFormat = nf(GY,2,2);}
          else if (abs(GY) < 1000.0) {GFormat = nf(GY,3,1);}
          else {GFormat = nf(GY,3,1);}
        } else {GFormat = "---.--";}
      } else {GFormat = "....";}
      fill(0,220,0); text(GFormat, 408, 776);
    } else {
      // data is now being plotted from a moving start point so we have
      // recalculate GX
      GX = GX + GraphPnt;
      if (GX >= GraphDepth) {GX = GX - GraphDepth;}
      if (G_Plot0) {
        GY = GraphVal0[GX];
        if (abs(GY) < 10.0) {GFormat = nf(GY,1,3);}
        else if (abs(GY) < 100.0) {GFormat = nf(GY,2,2);}
        else if (abs(GY) < 1000.0) {GFormat = nf(GY,3,1);}
        else {GFormat = nf(GY,3,1);}
      } else {GFormat = "....";}
      text(GFormat, 108, 776);
  
      if (G_Plot1) {
        GY = GraphVal1[GX];
        if (abs(GY) < 10.0) {GFormat = nf(GY,1,3);}
        else if (abs(GY) < 100.0) {GFormat = nf(GY,2,2);}
        else if (abs(GY) < 1000.0) {GFormat = nf(GY,3,1);}
        else {GFormat = nf(GY,3,1);}
      } else {GFormat = "....";}
      fill(255,0,0); text(GFormat, 208, 776);
  
      if (G_Plot2) {
        GY = GraphVal2[GX];
        if (abs(GY) < 10.0) {GFormat = nf(GY,1,3);}
        else if (abs(GY) < 100.0) {GFormat = nf(GY,2,2);}
        else if (abs(GY) < 1000.0) {GFormat = nf(GY,3,1);}
        else {GFormat = nf(GY,3,1);}
      } else {GFormat = "....";}
      fill(0,0,255); text(GFormat, 308, 776);
  
      if (G_Plot3) {
        GY = GraphVal3[GX];
        if (abs(GY) < 10.0) {GFormat = nf(GY,1,3);}
        else if (abs(GY) < 100.0) {GFormat = nf(GY,2,2);}
        else if (abs(GY) < 1000.0) {GFormat = nf(GY,3,1);}
        else {GFormat = nf(GY,3,1);}
      } else {GFormat = "....";}
      fill(0,220,0); text(GFormat, 408, 776);
    }
  }
}

// ----------------------------------------------------------------------

void drawGraphTitle() {
  // puts the received title at the top of the graph
  // title x positions are stored for data listing
  int zGX = 460; int zGI = 80; GTCX0 = zGX;
  if (G_Plot0) {TR =   0; TG =   0; TB =   0; drawTxtField(GraphTitle0,zGX,20);} zGX += zGI; GTCX1 = zGX;
  if (G_Plot1) {TR = 255; TG =   0; TB =   0; drawTxtField(GraphTitle1,zGX,20);} zGX += zGI; GTCX2 = zGX;
  if (G_Plot2) {TR =   0; TG =   0; TB = 255; drawTxtField(GraphTitle2,zGX,20);} zGX += zGI; GTCX3 = zGX;
  if (G_Plot3) {TR =   0; TG = 220; TB =   0; drawTxtField(GraphTitle3,zGX,20);} zGX += zGI;
  TR =   0; TG =   0; TB =   0; 
}

// ----------------------------------------------------------------------

void GraphAuto() {
  // toggle the graph scalling to Automatic
  G_Auto = !G_Auto;
  GraphMinMax(); G_Draw = true;
}

// ----------------------------------------------------------------------

void GraphMinMax() {
  // called to determine graph scaling limits
  if (G_Auto) {
    GMax0 = max(GraphVal0); GMin0 = min(GraphVal0);
    if (NumTraces > 1) {GMax1 = max(GraphVal1); GMin1 = min(GraphVal1);}
    if (NumTraces > 2) {GMax2 = max(GraphVal2); GMin2 = min(GraphVal2);}
    if (NumTraces > 3) {GMax3 = max(GraphVal3); GMin3 = min(GraphVal3);}
    
    if (NumTraces == 1) {GMax = GMax0; GMin = GMin0;}
    if (NumTraces >= 2) {GMax = max(GMax0,GMax1); GMin = min(GMin0,GMin1);}
    if (NumTraces >= 3) {GMax = max(GMax,GMax2); GMin = min(GMin,GMin2);}
    if (NumTraces == 4) {GMax = max(GMax,GMax3); GMin = min(GMin,GMin3);}
    if (GMax == GMin) {
      if (GMin == 0.0) {GMin = -0.1; GMax = 0.1;}
      else {GMax += 0.1;}
    }
  } else {GMax = G_Scale; GMin = -G_Scale;}
  // turn off traces if they are not valid data
  if (NumTraces < 2) {G_Plot1 = false;}
  if (NumTraces < 3) {G_Plot2 = false;}
  if (NumTraces < 4) {G_Plot3 = false;}
}

// ----------------------------------------------------------------------

void GraphMinus() {
  // decrease graph scaling or set to manual scaling mode
  if (G_Auto) {
    G_Auto = false;
  } else {
    // reduce scaling factor
    if (G_Scale == 10000.0) {G_Scale = 5000.0;}
    else if (G_Scale == 5000.0) {G_Scale = 2000.0;}
    else if (G_Scale == 2000.0) {G_Scale = 1000.0;}
    else if (G_Scale == 1000.0) {G_Scale = 500.0;}
    else if (G_Scale == 500.0) {G_Scale = 200.0;}
    else if (G_Scale == 200.0) {G_Scale = 100.0;}
    else if (G_Scale == 100.0) {G_Scale = 50.0;}
    else if (G_Scale == 50.0) {G_Scale = 20.0;}
    else if (G_Scale == 20.0) {G_Scale = 10.0;}
    else if (G_Scale == 10.0) {G_Scale = 5.0;}
    else if (G_Scale == 5.0) {G_Scale = 2.0;}
    else if (G_Scale == 2.0) {G_Scale = 1.0;}
    else if (G_Scale == 1.0) {G_Scale = 0.5;}
  } GraphMinMax(); G_Draw = true;
}

// ----------------------------------------------------------------------

void GraphPlus() {
  // decrease graph scaling or set to manual scaling mode
  if (G_Auto) {
    G_Auto = false;
  } else {
    // increase scaling factor
    if (G_Scale == 0.5) {G_Scale = 1.0;}
    else if (G_Scale == 1.0) {G_Scale = 2.0;}
    else if (G_Scale == 2.0) {G_Scale = 5.0;}
    else if (G_Scale == 5.0) {G_Scale = 10.0;}
    else if (G_Scale == 10.0) {G_Scale = 20.0;}
    else if (G_Scale == 20.0) {G_Scale = 50.0;}
    else if (G_Scale == 50.0) {G_Scale = 100.0;}
    else if (G_Scale == 100.0) {G_Scale = 200.0;}
    else if (G_Scale == 200.0) {G_Scale = 500.0;}
    else if (G_Scale == 500.0) {G_Scale = 1000.0;}
    else if (G_Scale == 1000.0) {G_Scale = 2000.0;}
    else if (G_Scale == 2000.0) {G_Scale = 5000.0;}
    else if (G_Scale == 5000.0) {G_Scale = 10000.0;}
  } GraphMinMax(); G_Draw = true;
}

// ----------------------------------------------------------------------

void InitGraphDraw() {
  // re-initialise graphing window
  clearArrays();
  GraphPnt = 0; GraphRange = 0;
  G_Pause = false; G_Draw = false; G_First = true;
  G_Plot0 = false; G_Plot1 = false; G_Plot2 = false; G_Plot3 = false;
  GraphSkip = true;  // ignore the first reading of data
}

// ----------------------------------------------------------------------

void SetGraphDepth() {
  // change the number of points in the graph plot
  if (mB == LEFT) {
    // left mouse button pressed
    switch (GraphDepth) {
      case 50: GraphDepth = 100; G_PxInc = 10; break;
      case 100: GraphDepth = 250; G_PxInc = 4; break;
      case 250: GraphDepth = 500;G_PxInc = 2; break;
    }
  } else {
    // assume RIGHT or CENTRE button
    switch (GraphDepth) {
      case 100: GraphDepth = 50;G_PxInc = 20; break;
      case 250: GraphDepth = 100; G_PxInc = 10; break;
      case 500: GraphDepth = 250; G_PxInc = 4; break;
    }
  }
  // change the size of the arrays
  GraphVal0 = expand(GraphVal0,GraphDepth);
  GraphVal1 = expand(GraphVal1,GraphDepth);
  GraphVal2 = expand(GraphVal2,GraphDepth);
  GraphVal3 = expand(GraphVal3,GraphDepth);
  // replot the graph with these new settings
  G_ON = true; GraphPnt = 0; GraphRange = 0;
  G_ReqCnt = 9; G_Pause = false; G_Draw = false; G_First = true;
  G_Plot0 = false; G_Plot1 = false; G_Plot2 = false; G_Plot3 = false;
}

// ----------------------------------------------------------------------

void SetRPnn() {
  // user has clicked on RPnn number field, so change the value
  // depending on which mouse button has been pressed
  if (mB == LEFT) {
    RPnn++;
    if (RPnn > RPnnMax) {RPnn = 0;}
  } else {
    // assume RIGHT or CENTRE button
    RPnn--;
    if (RPnn < 0) {RPnn = RPnnMax;}
  } G_ReqCnt = 9;
}

// ----------------------------------------------------------------------
